diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
index 75b22c5cf..d28f2b8f8 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
@@ -1,24 +1,20 @@
 package net.minecraft.core.player.inventory.menu;
 
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.IPainted;
-import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.item.*;
-import net.minecraft.core.item.tag.ItemTags;
+import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
-import net.minecraft.core.block.Blocks;
-import net.minecraft.core.player.inventory.CreativeBlocks;
-import net.minecraft.core.player.inventory.CreativeItems;
+import net.minecraft.core.player.inventory.CreativeMenuContents;
 import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.player.inventory.slot.SlotCreative;
-import net.minecraft.core.util.collection.NamespaceID;
-import net.minecraft.core.util.helper.DyeColor;
 
 import java.util.ArrayList;
 import java.util.List;
+import java.util.Objects;
 
 public class MenuInventoryCreative extends MenuInventory
 {
+	public static final int CREATIVE_COLUMNS = 6;
+	public static final int CREATIVE_PAGE_SIZE = CREATIVE_COLUMNS * CREATIVE_COLUMNS;
+
 	public int page = 0;
 	public int maxPage;
 	protected int creativeSlotsStart;
@@ -32,29 +28,28 @@ public class MenuInventoryCreative extends MenuInventory
 		creativeSlotsStart = this.slots.size();
 		
 		// Add creative slots
-		for (int i = 0; i < 36; i++)
+		for (int i = 0; i < CREATIVE_PAGE_SIZE; i++)
 		{
 			int x = i % 6;
 			int y = i / 6;
 			
-			addSlot(new SlotCreative(creativeSlotsStart + i, 184 + (x * 18), 30 + (y * 18), creativeItems.get(i)));
+			addSlot(new SlotCreative(creativeSlotsStart + i, 184 + (x * 18), 30 + (y * 18), creativeContents.get(i)));
 		}
 		
 		searchPage("");
 	}
-	
+
 	public void setInventoryStatus(int page, String searchText)
 	{
-		if (this.page != page)
-		{
+		String incoming = searchText == null ? "" : searchText;
+		if (!Objects.equals(this.searchText, incoming)) {
+			searchPage(incoming);
+			return;
+		}
+		if (this.page != page) {
 			this.page = page;
 			updatePage();
 		}
-		if (!this.searchText.equals(searchText))
-		{
-			this.searchText = searchText;
-			searchPage(searchText);
-		}
 	}
 	
 	public void lastPage()
@@ -65,51 +60,98 @@ public class MenuInventoryCreative extends MenuInventory
 		updatePage();
 	}
 	
+	/**
+	 * Advances one full page. {@link #searchedItems} is padded with trailing {@code null}
+	 * entries (in {@link #updatePage}) so the list length is always a multiple of {@link #CREATIVE_PAGE_SIZE},
+	 * keeping each page aligned to the grid.
+	 */
 	public void nextPage()
 	{
 		if (page == maxPage) return;
-		
+
 		page++;
 		updatePage();
 	}
+
+	public void jumpToFirstCreativePage() {
+		if (this.page <= 0) {
+			return;
+		}
+		this.page = 0;
+		this.updatePage();
+	}
+
+	public void jumpToLastCreativePage() {
+		if (this.page >= this.maxPage) {
+			return;
+		}
+		this.page = this.maxPage;
+		this.updatePage();
+	}
 	
 	public void searchPage(String search)
 	{
-		searchText = search;
-		searchedItems.clear();
-		page = 0;
-		I18n t = I18n.getInstance();
+		if (search == null) {
+			search = "";
+		}
+		this.searchText = search;
+		this.page = 0;
+		this.refillSearchedItemsMatchingCurrentQuery();
+		this.updatePage();
+	}
 
-		int itemsCount = creativeItems.size();
-		for (int i = 0; i < itemsCount; i++)
-		{
-			if (t.translateKey(creativeItems.get(i).getItemKey() + ".name").toLowerCase().contains(search.toLowerCase()))
-			{
-				searchedItems.add(creativeItems.get(i));
+	private void refillSearchedItemsMatchingCurrentQuery() {
+		this.searchedItems.clear();
+		final I18n t = I18n.getInstance();
+		final String needle = this.searchText.toLowerCase();
+		final int itemsCount = creativeContents.size();
+		for (int i = 0; i < itemsCount; i++) {
+			final ItemStack stack = creativeContents.get(i);
+			if (stack == null) {
+				if (this.searchText.isEmpty()) {
+					this.searchedItems.add(null);
+				}
+				continue;
+			}
+			if (t.translateKey(stack.getItemKey() + ".name").toLowerCase().contains(needle)) {
+				this.searchedItems.add(stack);
 			}
 		}
-		
-		updatePage();
 	}
 	
 	protected void updatePage()
 	{
-		maxPage = searchedItems.size() / 36;
-		if (searchedItems.size() % 36 == 0) maxPage--;
+		int n = searchedItems.size();
+		if (n > 0) {
+			int rem = n % CREATIVE_PAGE_SIZE;
+			if (rem != 0) {
+				for (int pad = 0; pad < CREATIVE_PAGE_SIZE - rem; pad++) {
+					searchedItems.add(null);
+				}
+			}
+		}
+
+		n = searchedItems.size();
+		maxPage = n / CREATIVE_PAGE_SIZE;
+		if (n % CREATIVE_PAGE_SIZE == 0) maxPage--;
 		if (maxPage == -1) maxPage = 0;
-		
-		for (int i = 0; i < 36; i++)
+		if (page > maxPage) {
+			page = maxPage;
+		}
+
+		for (int i = 0; i < CREATIVE_PAGE_SIZE; i++)
 		{
-			if (i + (page * 36) >= searchedItems.size())
+			int idx = i + page * CREATIVE_PAGE_SIZE;
+			if (idx >= n)
 			{
 				((SlotCreative)this.slots.get(creativeSlotsStart + i)).item = null;
 			}
 			else
 			{
-				((SlotCreative)this.slots.get(creativeSlotsStart + i)).item = searchedItems.get(i + (page * 36));
-			}			
+				((SlotCreative)this.slots.get(creativeSlotsStart + i)).item = searchedItems.get(idx);
+			}
 		}
-		
+
 		inventory.player.updateCreativeInventory(page, searchText);
 	}
 
@@ -122,59 +164,9 @@ public class MenuInventoryCreative extends MenuInventory
 		return number + 8 + 27;
 	}
 	
-	public static List<ItemStack> creativeItems = new ArrayList<>();
+	public static List<ItemStack> creativeContents = new ArrayList<>();
 
-	static
-	{
-		CreativeBlocks.populate(creativeItems);
-		CreativeItems.populate(creativeItems);
+	static {
+		CreativeMenuContents.populate(creativeContents);
 	}
-
-	// PREVIOUS IMPLEMENTATION:
-
-		/*for (Block<?> block : Blocks.blocksList) {
-			if (block == null || block.hasTag(BlockTags.NOT_IN_CREATIVE_MENU)) continue;
-
-			if (Block.hasLogicClass(block, IPainted.class)) {
-				IPainted painted = (IPainted) block.getLogic();
-				for (DyeColor color : DyeColor.values()) {
-					creativeItems.add(new ItemStack(block, 1, painted.toMetadata(color)));
-				}
-			} else if (block == Blocks.FLOWSTONE) {
-				for (int i = 0; i < 4; i++) {
-					creativeItems.add(new ItemStack(block, 1, i));
-				}
-			} else {
-				creativeItems.add(new ItemStack(block));
-			}
-		}
-		
-		for (int i = Blocks.blocksList.length; i < Item.itemsList.length; i++)
-		{
-			Item item = Item.itemsList[i];
-			if (item == null || item.hasTag(ItemTags.NOT_IN_CREATIVE_MENU)) continue;
-			if (item == Items.PAINTBRUSH) {
-				creativeItems.add(new ItemStack(item, 1, Items.PAINTBRUSH.getMaxDamage()));
-			} else if (item == Items.COAL) {
-				creativeItems.add(new ItemStack(item, 1, ItemCoal.META_COAL));
-				creativeItems.add(new ItemStack(item, 1, ItemCoal.META_CHARCOAL));
-			} else if (item == Items.DYE || item == Items.DOOR_OAK_PAINTED || item == Items.SIGN_PAINTED) {
-				for (DyeColor color : DyeColor.values()) {
-					creativeItems.add(new ItemStack(item, 1, color.itemMeta));
-				}
-           } else if (item instanceof ItemBucket bucket) {
-				creativeItems.add(new ItemStack(item));
-				for (NamespaceID stateId : ItemBucket.getRegisteredStateIds()) {
-					if (ItemBucket.STATE_EMPTY.equals(stateId)) continue;
-					ItemStack itemStack = new ItemStack(item, 1);
-					ItemBucket.setState(itemStack, stateId);
-					ItemBucket.setCharges(itemStack, bucket.maxCharges);
-
-					creativeItems.add(itemStack);
-				}
-			} else {
-				creativeItems.add(new ItemStack(item));
-			}
-		}
-	}*/
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
index bc07f6874..efa7e670d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
@@ -11,6 +11,10 @@ import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.*;
 import net.minecraft.core.world.generate.feature.*;
+import net.minecraft.core.world.generate.feature.WorldFeatureNetherScatterBonePile;
+import net.minecraft.core.world.generate.feature.WorldFeatureNetherScatterBoulderMagmatic;
+import net.minecraft.core.world.generate.feature.WorldFeatureNetherScatterBoulderSulfuric;
+import net.minecraft.core.world.generate.feature.WorldFeatureNetherScatterEmberAsh;
 import net.minecraft.core.world.noise.FractalNoise2D;
 import net.minecraft.core.world.noise.ImprovedPerlinNoise;
 import net.minecraft.core.world.noise.WorleyNoise;
@@ -266,13 +270,32 @@ public class ChunkDecoratorNether
                 .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
                 .withPlacementMethod(new PlacementMethod.TriesPerChunk(32)));
 
-        this.register("minecraft:decoration/nether/default/scatter", (new ChunkDecorationBuilder(new WorldFeatureNetherScatter()))
+        this.register("minecraft:decoration/nether/default/scatter_ember_ash", (new ChunkDecorationBuilder(new WorldFeatureNetherScatterEmberAsh()))
                 .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
-                .withPlacementMethod(new PlacementMethod.TriesPerChunk(32)));
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(20)));
+
+        this.register("minecraft:decoration/nether/default/scatter_bone_pile", (new ChunkDecorationBuilder(new WorldFeatureNetherScatterBonePile()))
+                .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(8)));
+
+        this.register("minecraft:decoration/nether/default/scatter_boulder_magmatic", (new ChunkDecorationBuilder(new WorldFeatureNetherScatterBoulderMagmatic()))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_CRAG, Biomes.NETHER_SHELF, Biomes.NETHER_VOLCANIC_ISLANDS})
+                .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(8)));
+
+        this.register("minecraft:decoration/nether/default/scatter_boulder_magmatic_sparce", (new ChunkDecorationBuilder(new WorldFeatureNetherScatterBoulderMagmatic()))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRYSTAL_PLAINS})
+                .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(4)));
+
+        this.register("minecraft:decoration/nether/default/scatter_boulder_sulfuric", (new ChunkDecorationBuilder(new WorldFeatureNetherScatterBoulderSulfuric()))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_SULFUR_POOLS})
+                .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(24)));
 
         this.register("minecraft:decoration/nether/default/patch_soul_catcher", (new ChunkDecorationBuilder(new WorldFeatureSoulCatcherPatch()))
                 .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
-                .withPlacementMethod(new PlacementMethod.TriesPerChunk(2)));
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(8)));
 
         this.register("minecraft:decoration/nether/default/pebbles", (world, chunk, worldX, worldZ, minY, maxY, rangeY, rand) -> {
             for (int i = 0; i < 16; ++i) {
@@ -305,7 +328,7 @@ public class ChunkDecoratorNether
                     if (world.isAirBlock(queryPose)) {
                         Block<?> blockBelow = world.getBlock(dx, dy - 1, dz);
 
-                        if (blockBelow != Blocks.OBSIDIAN && blockBelow.getMaterial().blocksMotion()
+                        if (blockBelow != Blocks.OBSIDIAN && blockBelow != Blocks.SOULSAND && blockBelow.getMaterial().blocksMotion()
                                 && !isRubyglassAshSupportForbidden(blockBelow)) {
 
                             Biome localBiome = world.getBlockBiome(queryPose);
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
index 9f48d9c37..80c28a081 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
@@ -165,16 +165,16 @@ public class SurfaceGeneratorNether implements SurfaceGenerator {
                         currentLayerDepth = soilThickness + 2;
 
                         if (y >= absoluteOceanY - 1) {
-                            result.setBlock(x, y, z, topBlock);
+                            result.setBlock(x, y, z, this.cragOrShelfFloorMixIfCobble(biome, topBlock, rand));
                         } else {
                             // if the block is below ocean level, set it to the chosen filler block
-                            result.setBlock(x, y, z, fillerBlock);
+                            result.setBlock(x, y, z, this.cragOrShelfFloorMixIfCobble(biome, fillerBlock, rand));
                         }
                         continue;
                     }
 
                     if (currentLayerDepth > 0) {
-                        result.setBlock(x, y, z, fillerBlock);
+                        result.setBlock(x, y, z, this.cragOrShelfFloorMixIfCobble(biome, fillerBlock, rand));
                         currentLayerDepth--;
                     }
 
@@ -196,6 +196,13 @@ public class SurfaceGeneratorNether implements SurfaceGenerator {
         }
     }
 
+    private short cragOrShelfFloorMixIfCobble(final @NotNull Biome biome, final short blockId, final @NotNull Random rand) {
+        if ((biome != Biomes.NETHER_CRAG && biome != Biomes.NETHER_SHELF) || blockId != this.cobbleNetherrackId) {
+            return blockId;
+        }
+        return (short) (rand.nextInt(2) == 0 ? this.netherrackId : this.cobbleNetherrackId);
+    }
+
     private int computeBiomeStoneBlock(Biome biome, int worldFillBlock) {
         if (biome == Biomes.NETHER_VOLCANIC_ISLANDS) {
             return brimsandId;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
index 08ede7be9..06ac14c92 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
@@ -710,7 +710,9 @@ public class ChunkDecoratorOverworld
 
         final boolean wantsSnow = localBiome.hasTag(BiomeTags.HAS_SURFACE_SNOW) || this.world.getWorldType().hasTag(WorldTypeTags.ENDLESS_SNOW);
         if (wantsSnow && dy > 0 && dy < this.world.getHeightBlocks()) {
-            if (this.world.isAirBlock(dx, dy, dz) && this.world.getBlockMaterial(dx, dy - 1, dz).blocksMotion()) {
+            if (this.world.isAirBlock(dx, dy, dz)
+                    && this.world.getBlockMaterial(dx, dy - 1, dz).blocksMotion()
+                    && this.world.getBlockMaterial(dx, dy - 1, dz) != Materials.ICE) {
                 this.world.setBlockWithNotify(dx, dy, dz, Blocks.LAYER_SNOW.id());
             }
             final int minScanY = Math.max(1, dy - 32);
@@ -737,7 +739,7 @@ public class ChunkDecoratorOverworld
                         continue;
                     }
                     if (below.getMaterial() == Materials.WOOD) { continue; }
-                    if (below.getMaterial().blocksMotion()) {
+                    if (below.getMaterial().blocksMotion() && below.getMaterial() != Materials.ICE) {
                         this.world.setBlockWithNotify(dx, scanY, dz, Blocks.LAYER_SNOW.id());
                         break;
                     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
index d518830a0..9bb496bd1 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
@@ -375,7 +375,9 @@ public class ChunkDecoratorOverworldB173
         final Biome localBiome = this.world.getBlockBiome(xx, yy, zz);
 
         if (localBiome.hasTag(BiomeTags.HAS_SURFACE_SNOW) && yy > 0 && yy < this.world.getHeightBlocks()) {
-            if (this.world.isAirBlock(xx, yy, zz) && this.world.getBlockMaterial(xx, yy - 1, zz).blocksMotion()) {
+            if (this.world.isAirBlock(xx, yy, zz)
+                    && this.world.getBlockMaterial(xx, yy - 1, zz).blocksMotion()
+                    && this.world.getBlockMaterial(xx, yy - 1, zz) != Materials.ICE) {
                 this.world.setBlockWithNotify(xx, yy, zz, Blocks.LAYER_SNOW.id());
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureBoulderMagma.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureBoulderMagma.java
index 8ce53846e..9fa9c0a00 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureBoulderMagma.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureBoulderMagma.java
@@ -42,12 +42,14 @@ public class WorldFeatureBoulderMagma implements WorldFeatureInterface {
                         circlePos.set(x, y, z);
                         if (!world.isAirBlock(circlePos)) {
                             if (random.nextInt(8) == 0) {
-                                world.setBlockType(circlePos, Blocks.COBBLE_BASALT);
+                                world.setBlockType(circlePos, Blocks.ORE_NETHERCOAL_NETHERRACK);
                             }
                         }
                     }
                 }
             }
+
+            world.setBlockType(queryPos.set(pos.x(), pos.y() + 1, pos.z()), Blocks.BLOCK_NETHER_COAL);
         }
 
         return true;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherScatter.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherScatter.java
index fe0c402e1..7a21f1484 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherScatter.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherScatter.java
@@ -12,137 +12,42 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class WorldFeatureNetherScatter implements WorldFeatureInterface {
-    private static final int MAX_DOWN_SCAN = 96;
-    private static final int BONE_PILE_ON_ASH_RARE_ONE_IN = 8;
-    private static final int EMBER_FIRST_ROLL_SIDES = 4;
-    private static final int EMBER_FIRST_ROLL_THRESHOLD = 1;
+public abstract class WorldFeatureNetherScatter implements WorldFeatureInterface {
+    protected static final int MAX_DOWN_SCAN = 96;
 
-    private final TilePos scratchGround = new TilePos();
-    private final TilePos scratchPlace = new TilePos();
-    private final TilePos scratchProbe = new TilePos();
-    private final TilePos scratchNeighbor = new TilePos();
-
-    @Override
-    public boolean place(@NotNull World world, @NotNull Random random, @NotNull TilePosc tilePos) {
-        if (random.nextInt(EMBER_FIRST_ROLL_SIDES) >= EMBER_FIRST_ROLL_THRESHOLD) {
-            final Biome seedBiome = world.getBlockBiome(tilePos);
-            if (isOldWorldBiome(seedBiome)) {
-                if (this.tryPlaceEmberReplacingAsh(world, tilePos)) {
-                    return true;
-                }
-            }
-        }
+    protected final @NotNull TilePos scratchGround = new TilePos();
+    protected final @NotNull TilePos scratchPlace = new TilePos();
+    protected static boolean isRubyglassScatterForbiddenSurface(final @NotNull Block<?> surface) {
+        return surface == Blocks.RUBYGLASS_NODE
+            || surface == Blocks.RUBYGLASS_COLUMN
+            || surface == Blocks.RUBYGLASS_GROWTH;
+    }
 
-        final TilePos ground = this.scratchGround.set(tilePos.x(), tilePos.y(), tilePos.z());
+    protected boolean resolveSurfaceScatterSite(final @NotNull World world, final @NotNull TilePosc start) {
+        this.scratchGround.set(start.x(), start.y(), start.z());
         int scanned = 0;
-        while (world.isAirBlock(ground) && ground.y() > 0 && scanned < MAX_DOWN_SCAN) {
-            ground.down();
+        while (world.isAirBlock(this.scratchGround) && this.scratchGround.y() > 0 && scanned < MAX_DOWN_SCAN) {
+            this.scratchGround.down();
             scanned++;
         }
-        if (ground.y() <= 0) { return false; }
-
-        final Block<?> surface = world.getBlockType(ground);
-
-        if (isRubyglassScatterForbiddenSurface(surface)) {
+        if (this.scratchGround.y() <= 0) {
             return false;
         }
-
-        final TilePos placePos = this.scratchPlace.set(ground.x(), ground.y() + 1, ground.z());
-        if (!world.isAirBlock(placePos)) { return false; }
-
-        final Block<?> chosen = pickDecoration(world, random, placePos, surface);
-
-        if (chosen == Blocks.BOULDER_MAGMATIC && surface != Blocks.COBBLE_NETHERRACK && surface != Blocks.NETHERRACK) {
+        final Block<?> surface = world.getBlockType(this.scratchGround);
+        if (isRubyglassScatterForbiddenSurface(surface)) {
             return false;
         }
-        if (chosen == Blocks.BOULDER_SULFURIC && surface != Blocks.BRIMSAND && surface != Blocks.BRIMSTONE && surface != Blocks.BRIMTHAW) {
+        this.scratchPlace.set(this.scratchGround.x(), this.scratchGround.y() + 1, this.scratchGround.z());
+        return world.isAirBlock(this.scratchPlace);
+    }
+
+    protected boolean placeIfCanStay(final @NotNull World world, final @NotNull Block<?> chosen, final @NotNull TilePos placePos) {
+        if (!chosen.canStay(world, placePos)) {
             return false;
         }
-        if (chosen == Blocks.BONE_PILE && isAshSurface(surface)) {
-            if (random.nextInt(BONE_PILE_ON_ASH_RARE_ONE_IN) != 0) {
-                return false;
-            }
-        }
-        if (!chosen.canStay(world, placePos)) { return false; }
-
         world.setBlockType(placePos, chosen);
         return true;
     }
 
-    private static boolean isOldWorldBiome(final @Nullable Biome biome) {
-        return biome == Biomes.NETHER_OLD_WORLD || biome == Biomes.NETHER_OLD_WORLD_DESERT;
-    }
-
-    private static boolean isAshSurface(final @NotNull Block<?> surface) {
-        return surface == Blocks.BLOCK_ASH || surface == Blocks.LAYER_ASH;
-    }
-
-    private static boolean isRubyglassScatterForbiddenSurface(final @NotNull Block<?> surface) {
-        return surface == Blocks.RUBYGLASS_NODE
-                || surface == Blocks.RUBYGLASS_COLUMN
-                || surface == Blocks.RUBYGLASS_GROWTH;
-    }
-
-    private boolean tryPlaceEmberReplacingAsh(final @NotNull World world, final @NotNull TilePosc start) {
-        final int x = start.x();
-        final int z = start.z();
-        final TilePos probe = this.scratchProbe;
-
-        int scanned = 0;
-        for (int y = start.y(); y > 0 && scanned < MAX_DOWN_SCAN; y--, scanned++) {
-            probe.set(x, y, z);
-
-            if (world.getBlockType(probe) != Blocks.BLOCK_ASH) {
-                continue;
-            }
-
-            final TilePos above = this.scratchPlace.set(x, y + 1, z);
-            if (!world.isAirBlock(above)) {
-                continue;
-            }
-
-            if (!isOldWorldBiome(world.getBlockBiome(probe))) {
-                continue;
-            }
-
-            if (!this.isAshSurroundedByAsh(world, x, y, z)) {
-                continue;
-            }
-
-            world.setBlockType(probe, Blocks.EMBER);
-            if (Blocks.LAYER_ASH.canPlaceAt(world, above)) {
-                world.setBlockType(above, Blocks.LAYER_ASH);
-            }
-            return true;
-        }
-        return false;
-    }
-
-    private boolean isAshSurroundedByAsh(final @NotNull World world, final int ax, final int ay, final int az) {
-        final TilePos n = this.scratchNeighbor;
-        return world.getBlockType(n.set(ax + 1, ay, az)) == Blocks.BLOCK_ASH
-                && world.getBlockType(n.set(ax - 1, ay, az)) == Blocks.BLOCK_ASH
-                && world.getBlockType(n.set(ax, ay, az + 1)) == Blocks.BLOCK_ASH
-                && world.getBlockType(n.set(ax, ay, az - 1)) == Blocks.BLOCK_ASH;
-    }
-
-    private @NotNull Block<?> pickDecoration(final @NotNull World world, final @NotNull Random random,
-                                             final @NotNull TilePos placePos, final @NotNull Block<?> surface) {
-        if (surface == Blocks.OBSIDIAN) {
-            return Blocks.BONE_PILE;
-        }
-
-        final Biome biome = world.getBlockBiome(placePos);
-        if (biome == Biomes.NETHER_SULFUR_POOLS) {
-            return random.nextBoolean() ? Blocks.BONE_PILE : Blocks.BOULDER_SULFURIC;
-        }
-        if (biome == Biomes.NETHER_VOLCANIC_ISLANDS || biome == Biomes.NETHER_CRAG
-                || biome == Biomes.NETHER_CRYSTAL_PLAINS || biome == Biomes.NETHER_CRYSTAL_FOREST
-                || biome == Biomes.NETHER_SHELF) {
-            return random.nextBoolean() ? Blocks.BONE_PILE : Blocks.BOULDER_MAGMATIC;
-        }
-
-        return Blocks.BONE_PILE;
-    }
-}
\ No newline at end of file
+    public abstract boolean place(final @NotNull World world, final @NotNull Random random, final @NotNull TilePosc tilePos);
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherScatterBonePile.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherScatterBonePile.java
new file mode 100644
index 000000000..09a03abe6
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherScatterBonePile.java
@@ -0,0 +1,29 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Random;
+
+public final class WorldFeatureNetherScatterBonePile extends WorldFeatureNetherScatter {
+    private static final int BONE_PILE_ON_ASH_ONE_IN = 8;
+
+    private static boolean isAshSurface(final @NotNull Block<?> surface) {
+        return surface == Blocks.BLOCK_ASH || surface == Blocks.LAYER_ASH;
+    }
+
+    @Override
+    public boolean place(final @NotNull World world, final @NotNull Random random, final @NotNull TilePosc tilePos) {
+        if (!this.resolveSurfaceScatterSite(world, tilePos)) {
+            return false;
+        }
+        final Block<?> surface = world.getBlockType(this.scratchGround);
+        if (isAshSurface(surface) && random.nextInt(BONE_PILE_ON_ASH_ONE_IN) != 0) {
+            return false;
+        }
+        return this.placeIfCanStay(world, Blocks.BONE_PILE, this.scratchPlace);
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherScatterBoulderMagmatic.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherScatterBoulderMagmatic.java
new file mode 100644
index 000000000..e8a390ee7
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherScatterBoulderMagmatic.java
@@ -0,0 +1,22 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
+
+public final class WorldFeatureNetherScatterBoulderMagmatic extends WorldFeatureNetherScatter {
+
+    @Override
+    public boolean place(final @NotNull World world, final @NotNull Random random, final @NotNull TilePosc tilePos) {
+        if (!this.resolveSurfaceScatterSite(world, tilePos)) {
+            return false;
+        }
+        return this.placeIfCanStay(world, Blocks.BOULDER_MAGMATIC, this.scratchPlace);
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherScatterBoulderSulfuric.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherScatterBoulderSulfuric.java
new file mode 100644
index 000000000..f23054f9f
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherScatterBoulderSulfuric.java
@@ -0,0 +1,26 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
+
+public final class WorldFeatureNetherScatterBoulderSulfuric extends WorldFeatureNetherScatter {
+    @Override
+    public boolean place(final @NotNull World world, final @NotNull Random random, final @NotNull TilePosc tilePos) {
+        if (!this.resolveSurfaceScatterSite(world, tilePos)) {
+            return false;
+        }
+        final Block<?> surface = world.getBlockType(this.scratchGround);
+        if (surface != Blocks.BRIMSAND && surface != Blocks.BRIMSTONE && surface != Blocks.BRIMTHAW) {
+            return false;
+        }
+        return this.placeIfCanStay(world, Blocks.BOULDER_SULFURIC, this.scratchPlace);
+    }
+}
